﻿using LibW4M.Data.InputMapping;
using LibW4M.Data.Teams;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace W4Gui.Tabs
{
    public partial class InputEventMappingTab : TabEntry
    {
        public InputEventMappingTab()
        {
            InitializeComponent();
            this.inputEventMappingList.List.Selected += inputEventMappingList_Selected;
            this.inputEventMappingList.List.Unselected += inputEventMappingList_Unselected;

        }

        public override void SaveFromControl()
        {
            if (this.inputEventMappingList.List.IsItemSelected)
                inputEventMappingList_Unselected(null, null);
        }

        public override void LoadIntoControl()
        {
            this.inputEventMappingList.List.LoadCollective(DataManager.SaveFile.InputMappingCollective);
            inputEventMappingPanel.Enabled = false;
        }

        private void inputEventMappingList_Unselected(object? sender, EventArgs e)
        {
            InputEventMappingData inputEventMappingData = DataManager.SaveFile.InputMappingCollective[inputEventMappingList.List.LastSelected] as InputEventMappingData;
            inputEventMappingPanel.SaveInputEventMappingsData(ref inputEventMappingData);
            inputEventMappingList.List.UpdateName(inputEventMappingList.List.LastSelected, inputEventMappingData.FriendlyName);
        }

        private void inputEventMappingList_Selected(object? sender, EventArgs e)
        {
            InputEventMappingData inputEventMappingData = DataManager.SaveFile.InputMappingCollective[inputEventMappingList.List.CurrentlySelected] as InputEventMappingData;
            inputEventMappingPanel.LoadInputEventMappingsData(inputEventMappingData);
            inputEventMappingPanel.Enabled = true;
        }

        private void inputEventMappingList_NewButton(object sender, EventArgs e)
        {
            DataManager.SaveFile.InputMappingCollective.Create();
            inputEventMappingList.List.Add(DataManager.SaveFile.InputMappingCollective.Last().FriendlyName);
            inputEventMappingList.List.SelectedIndex = (inputEventMappingList.List.Items.Count - 1);
        }

        private void inputEventMappingList_DelButton(object sender, EventArgs e)
        {
            int sel = inputEventMappingList.List.CurrentlySelected;
            InputEventMappingData inputEventMappingData = DataManager.SaveFile.InputMappingCollective[sel] as InputEventMappingData;
            DataManager.SaveFile.InputMappingCollective.Delete(inputEventMappingData);
            inputEventMappingList.List.Delete(sel);
        }

    }
}
