﻿using LibW4M.Data.Stats;
using LibW4M.Data.Teams;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace W4Gui.Tabs.StatsTab
{
    public partial class StatisticsTab : TabEntry
    {
        public StatisticsTab()
        {
            InitializeComponent();
            this.statisticsList.List.Selected += statisticsList_Selected;
            this.statisticsList.List.Unselected += statisticsList_Unselected;

        }

        public override void SaveFromControl()
        {
            if (this.statisticsList.List.IsItemSelected)
                statisticsList_Unselected(null, null);
        }

        public override void LoadIntoControl()
        {
            this.statisticsList.List.LoadCollective(DataManager.SaveFile.StatsCollective);
            statisticsPanel.Enabled = false;
        }

        private void statisticsList_Unselected(object? sender, EventArgs e)
        {
            StatsContainerData statsData = DataManager.SaveFile.StatsCollective[statisticsList.List.LastSelected] as StatsContainerData;
            statisticsPanel.SaveStatsData(ref statsData);
            statisticsList.List.UpdateName(statisticsList.List.LastSelected, statsData.FriendlyName);
        }

        private void statisticsList_Selected(object? sender, EventArgs e)
        {
            StatsContainerData statsData = DataManager.SaveFile.StatsCollective[statisticsList.List.CurrentlySelected] as StatsContainerData;
            statisticsPanel.LoadStatsData(statsData);
            statisticsPanel.Enabled = true;
        }

        private void statisticsList_NewButton(object sender, EventArgs e)
        {
            DataManager.SaveFile.StatsCollective.Create();
            statisticsList.List.Add(DataManager.SaveFile.StatsCollective.Last().FriendlyName);
            statisticsList.List.SelectedIndex = (statisticsList.List.Items.Count - 1);
        }

        private void statisticsList_DelButton(object sender, EventArgs e)
        {
            int sel = statisticsList.List.CurrentlySelected;
            StatsContainerData statsData = DataManager.SaveFile.StatsCollective[sel] as StatsContainerData;
            DataManager.SaveFile.StatsCollective.Delete(statsData);
            statisticsList.List.Delete(sel);
        }

    }
}
