﻿using LibW4M.Data.Highscores;
using LibW4M.Data.Teams;
using LibW4M.Data.WXFE.UnlockableItem;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace W4Gui.Tabs
{
    public partial class UnlockableItemsTab : TabEntry
    {
        public UnlockableItemsTab()
        {
            InitializeComponent();
            this.unlockableItemsList.Selected += unlockableItemsList_Selected;
            this.unlockableItemsList.Unselected += unlockableItemsList_Unselected;

        }

        public override void SaveFromControl()
        {
            if (this.unlockableItemsList.IsItemSelected)
                unlockableItemsList_Unselected(null, null);
        }

        public override void LoadIntoControl()
        {
            this.unlockableItemsList.LoadArray(DataManager.SaveFile.UnlockableItems);
            unlockableItemsPanel.Enabled = false;
        }

        private void unlockableItemsList_Unselected(object? sender, EventArgs? e)
        {
            UnlockableItemData itemData = DataManager.SaveFile.UnlockableItems[unlockableItemsList.LastSelected] as UnlockableItemData;
            unlockableItemsPanel.SaveUnlockableItem(ref itemData);
            unlockableItemsList.UpdateName(unlockableItemsList.LastSelected, itemData.FriendlyName);
        }

        private void unlockableItemsList_Selected(object? sender, EventArgs? e)
        {
            UnlockableItemData itemData = DataManager.SaveFile.UnlockableItems[unlockableItemsList.CurrentlySelected] as UnlockableItemData;
            unlockableItemsPanel.LoadUnlockableItem(itemData);
            unlockableItemsPanel.Enabled = true;
        }

    }
}
